#include <iostream>
#include "app/Application.h"   // Be's BApplication class, necessary for any GUI stuff
#include "interface/Window.h"  // Be's BWindow class
#include "interface/Alert.h"   // Be's BAlert class
#include "interface/View.h"   // Be's View class

//custom BWindow subclass
class BrentWindow : public BWindow
{
	public:
		BrentWindow();
		virtual bool QuitRequested();
	
};
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,250,150), "Brent's Window!", B_TITLED_WINDOW, 0)
{
	BView* myview = new BView(Bounds(),NULL,B_FOLLOW_ALL_SIDES,0);
	BAlert* myalert = new BAlert("Brent's Alert", "Which colour would you like the window to be?","Red",
	"Orange", "Yellow",
	B_WIDTH_FROM_LABEL,B_EVEN_SPACING,B_WARNING_ALERT);
	
	myalert->SetShortcut(0,B_ESCAPE);
	int32 button_index = myalert->Go();
	if(button_index == 0)
	{
	//cout << "Making view red" << endl;
	myview->SetViewColor(199,22,0);
	AddChild(myview);
	}
	if(button_index == 1)
	{
	
	myview->SetViewColor(255,142,1);
	AddChild(myview);
	}
	if(button_index == 2)
	{
	
	myview->SetViewColor(255,209,1);
	AddChild(myview);
	}

}
// Called when the user clicks on the window's close box
bool BrentWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}

int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.Brent-template");//gotta have this
	//Create the window..
	BWindow* window = new BrentWindow();
	window->Show();	//shows up the window
	app.Run();
	return 0;
}
