#include <Application.h>
#include <stdio.h>
#include <Window.h>
#include <Button.h>

const BRect kWindowFrame (100,100,300,300);
const BRect kButtonFrame (80, 90, 120, 110);
const char* kWindowName = "ButtonWindow";
const char* kButtonName = "Press";


#define BUTTON_MSG 'PRES'
#define BUTTON_DEC 'DECR'

class BTSButtonWindow : public BWindow
{
	public:
						BTSButtonWindow();
		virtual bool	QuitRequested();
		virtual void	MessageReceived(BMessage* message);
	private:
		BButton*		fButton;
		BButton*		dec_button;
};
//BTSButtonWindow constructor
BTSButtonWindow::BTSButtonWindow() :
	BWindow(kWindowFrame, kWindowName, B_TITLED_WINDOW,
			B_WILL_DRAW)
{
	fButton = new BButton(kButtonFrame, kButtonName, kButtonName,
					new BMessage(BUTTON_MSG));
	AddChild(fButton);
	
	dec_button = new BButton(BRect(10,10,70,80), NULL, "Decrement", new BMessage(BUTTON_DEC));
	AddChild(dec_button);

}


bool
BTSButtonWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return BWindow::QuitRequested();
}

void
BTSButtonWindow::MessageReceived(BMessage* message)
{
	static int numPresses = 0;
	char title[100];
	switch(message->what)
	{
		case BUTTON_MSG:
			
			sprintf(title, "Presses: %d", ++numPresses);
			SetTitle(title);
		break;
		case BUTTON_DEC:
			
			sprintf(title, "Presses: %d", --numPresses);
			SetTitle(title);
		break;
		default:
			BWindow::MessageReceived(message);
	}
}
//#define BUTTON_APP_SIG ""

class BTSButtonApp: public BApplication
{
	public:
						BTSButtonApp();
		virtual void	ReadyToRun();
	private:
		BTSButtonWindow*	fWindow;
};
BTSButtonApp::BTSButtonApp()
	: BApplication("application/x-vnd.Be-BasicButton")
{
}

void
BTSButtonApp::ReadyToRun()
{
	fWindow = new BTSButtonWindow();
	fWindow->Show();
}

int main(int, char**)
{
	BTSButtonApp* app2 = new BTSButtonApp();
	app2->Run();
	
	return(0);
}
