#include <iostream>
#include <stdio.h>
#include <Application.h>   // Be's BApplication class, necessary for any GUI stuff
#include <Window.h>  // Be's BWindow class
#include <Box.h>	   // Be's BBox class
#include <View.h>	   //Be's BView class
#include <string>
#include <Button.h>
#include <Roster.h>

//custom BWindow subclass

const uint32 BRENT_DO_THIS = 'DoIt';
const uint32 SOME_CONSTANT = 'Some';
class BrentWindow : public BWindow
{
	public:
		BrentWindow();
		virtual void MessageReceived(BMessage * msg);
		virtual bool QuitRequested();
	
};
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,250,250), "Brent's Window!", B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{
	rgb_color bgcolor = ui_color(B_PANEL_BACKGROUND_COLOR);
	/*---TOP VIEW----*/
	
	BRect b = Frame();
	b.OffsetTo(B_ORIGIN);
	BView* parent_view = new BBox(b,"parent_view", B_FOLLOW_ALL, B_WILL_DRAW | B_FRAME_EVENTS | B_FULL_UPDATE_ON_RESIZE, B_PLAIN_BORDER);
	
	
	parent_view->SetLowColor(bgcolor);
	parent_view->SetViewColor(bgcolor);
	AddChild(parent_view);
	
	/*------NEXT VIEW-----*/
	BRect r = parent_view->Bounds();
	r.InsetBy(10,10);
	BBox* brents_bbox = new BBox(r,"Brent's BBox", B_FOLLOW_ALL);
	//Set the color and Label of the BBox/view
	brents_bbox->SetLowColor(bgcolor);
	brents_bbox->SetViewColor(bgcolor);
	
	//Set the label
	brents_bbox->SetLabel("Brent's BBox");
	//add it to hierarchy
	parent_view->AddChild(brents_bbox);
	/*----SOME BUTTONS----*/
	BButton* button = new BButton(BRect(20,40,105,75),NULL,"Launch Net+", new BMessage(BRENT_DO_THIS),B_NOT_RESIZABLE);
	button->SetTarget(this);
	button->MakeDefault(true);
	brents_bbox->AddChild(button);
	
	BButton* button2 = new BButton(BRect(60,80,165,115),NULL,"Launch CDBurner", new BMessage(SOME_CONSTANT),B_NOT_RESIZABLE);
	button2->SetTarget(this);
	brents_bbox->AddChild(button2);
}
void BrentWindow :: MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case BRENT_DO_THIS:
			
			be_roster->Launch("application/x-vnd.Be-NPOS");
			//cout << "Net+ Launched" << endl;
		break;
		case SOME_CONSTANT:
		be_roster->Launch("application/x-vnd.Be.Burner");
		break;
		default:
		BWindow :: MessageReceived(msg);// all other types go to the parent class's method.
		break;
	}
}

// Called when the user clicks on the window's close box
bool BrentWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}

int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.Brent-bbox");//gotta have this
	//Create the window..
	BWindow* window = new BrentWindow();
	window->Show();	//shows up the window
	app.Run();
	return 0;
}
