#include <iostream>
#include <stdio.h>
#include "app/Application.h"   // Be's BApplication class, necessary for any GUI stuff
#include "interface/Window.h"  // Be's BWindow class
#include "interface/View.h"    // Be's BView class
#include "interface/Button.h"  // Be's BButton class

const uint32 BRENT_DO_SOMETHING = 'DoIt';
//custom BWindow subclass
class BrentWindow : public BWindow
{
	public:
		BrentWindow();
	virtual void MessageReceived(BMessage * msg);
	virtual bool QuitRequested();
	
};
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,250,150), "Brent's Window!", B_TITLED_WINDOW, 0)
{
    // Fill this window with a nice light green background BView...
   BView * view = new BView(Bounds(), NULL, B_FOLLOW_ALL_SIDES, 0);
   view->SetViewColor(23,0,164);
   AddChild(view);
   //SetFeel(B_FLOATING_ALL_WINDOW_FEEL);
  
   
   //Add a button
   BRect buttonRect = view->Bounds();
   buttonRect.InsetBy(20,30); //inset it
   
   BButton* button = new BButton(buttonRect, NULL, "Brent's Button", new BMessage(BRENT_DO_SOMETHING), B_FOLLOW_ALL_SIDES, B_WILL_DRAW|B_FULL_UPDATE_ON_RESIZE);
   button->SetTarget(this);	//so that when the button is pressed, its BMessage is sent to this window.
   view->AddChild(button);
   
 //create a little orange bit inside the blue bit
//   BView* little_rect_inside = new BView(BRect(5,5,10,10), NULL, B_FOLLOW_NONE, 0);
//   little_rect_inside->SetViewColor(255,186,0);
 //  AddChild(little_rect_inside);
}

void BrentWindow :: MessageReceived(BMessage* msg)
{
	cout << "We have a msg! It is:\n";
	msg->PrintToStream();
	
	switch(msg->what)
	{
		case BRENT_DO_SOMETHING:
			cout << "I pushed my button!" << endl;
		break;
		
		default:
		BWindow :: MessageReceived(msg);// all other types go to the parent class's method.
		break;
	}
}
// Called when the user clicks on the window's close box
bool BrentWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}

int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.Brent-brentwindow");//gotta have this
	//Create the window..
	BWindow* window = new BrentWindow();
	window->Show();	//shows up the window
	app.Run();
	return 0;
}
