#include "StatusWindow.h"
StatusWindow::StatusWindow() : BWindow(BRect(50,50,300,200),"BStatusBarPulse", B_TITLED_WINDOW,B_NOT_RESIZABLE| B_NOT_ZOOMABLE|B_ASYNCHRONOUS_CONTROLS)
{
	
	SetFeel(B_FLOATING_ALL_WINDOW_FEEL);//nice and on top of EVERYTHING :P
	
	parent = new BView(Bounds(),"parent", B_FOLLOW_ALL, B_WILL_DRAW | B_FRAME_EVENTS);
	parent->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(parent);

	system_info info; 
	get_system_info(&info);
	
	//calc memsizes
	max = (info.max_pages*B_PAGE_SIZE)/(1024*1024);
	used = (info.used_pages*B_PAGE_SIZE)/(1024*1024);
	//Make some strings for the labels
	
	BString TRAILING;
	TRAILING << (int32)used << " / " << (int32)(max) << "MB"; 

	//for ram
	BRect memrect(20,100,230,140);
	ram_usage = new BStatusBar(memrect,"ram_usage");
	ram_usage->SetMaxValue(max);//set the size of the bar to correspond with max ram size
	ram_usage->SetText("Memory: ");//add a pretty label
	parent->AddChild(ram_usage);
	ram_usage->Update(used);//set initial value of mem usage
	ram_usage->SetTrailingText(TRAILING.String());//add another pretty label
	ram_usage->SetBarHeight(12.0);
	last_used = used;
		
	last_active_cpu_time = (double)info.cpu_infos[0].active_time;
	last_active_cpu_time2 = (double)info.cpu_infos[1].active_time;
	
	
	BString cpu1_label;
	BString cpu2_label;
	const rgb_color brghtgrn = {0,255,0};

	BRect statbarrect(50,20,230,60);
	//for first cpu
	cpu1_usage = new BStatusBar(statbarrect,"cpu1_usage");
	cpu1_usage->SetMaxValue(100.00);
	parent->AddChild(cpu1_usage);
	cpu1_usage->SetBarColor(brghtgrn);
	cpu1_usage->SetBarHeight(12.0);
	statbarrect.OffsetBy(0,40);

	CPU1 = new BCheckBox(BRect(20,31,50,51),"CPU1","1",
	new BMessage(TURN_OFF_CPU_1));
	
	parent->AddChild(CPU1);
		
	//for second cpu
	cpu2_usage = new BStatusBar(statbarrect,"cpu2_usage");
	cpu2_usage->SetMaxValue(100.00);
	parent->AddChild(cpu2_usage);
	cpu2_usage->SetBarColor(brghtgrn);
	cpu2_usage->SetBarHeight(12.0);
	UpdateCPUPercent();
	

	CPU2 = new BCheckBox(BRect(20,71,50,91),"CPU2","2",
	new BMessage(TURN_OFF_CPU_2));
	
	
	parent->AddChild(CPU2);
	
				if(_kget_cpu_state_(0) == 0)
				{
					CPU1->SetValue(B_CONTROL_ON);
					CPU2->SetEnabled(false);
				}
				else if(_kget_cpu_state_(0) == 1)
				{
					CPU1->SetValue(B_CONTROL_OFF);
					CPU2->SetEnabled(true);
				}
				if(_kget_cpu_state_(1) == 0)
				{	
					CPU2->SetValue(B_CONTROL_ON);
					CPU1->SetEnabled(false);
				}
				else if(_kget_cpu_state_(1) == 1)
				{	
					CPU2->SetValue(B_CONTROL_OFF);
					CPU1->SetEnabled(true);
				}	
	cpu1_label << "CPU 1: " << (float)percent*100 << "%";
	cpu2_label << "CPU 2: " << (float)percent2*100 << "%";

	cpu1_usage->SetText(cpu1_label.String());
	cpu1_usage->Update(percent*100);
	
	
	cpu2_usage->SetText(cpu2_label.String());
	cpu2_usage->Update(percent*100);
		 
	lastpercent = percent;
	lastpercent2 = percent2;
	
	last_system_time = (double)system_time();//set an initial value
	
	
	
	BMessenger mymsnger(this);
	BMessage update_ram(STARTME);
	//sends lots of BMessages (STARTME) (1 every 10000 µs) infinitely (-1)
	update = new BMessageRunner(mymsnger,&update_ram,UPDATE_TIME_AMOUNT,-1);
	
}

void StatusWindow::UpdateCPUPercent()
{
	system_info info;
	get_system_info(&info);
	
	delta_system = (double)system_time() - last_system_time;
	
	//cpu 1
	delta_cpu = double(info.cpu_infos[0].active_time) - last_active_cpu_time;
	
	percent = (delta_cpu/delta_system);
	if(percent < 0) percent = 0.00;
	if(percent > 1) percent = 1.00;
	
	last_active_cpu_time = (double)info.cpu_infos[0].active_time;
	
	//cpu 2
	delta_cpu2 = double(info.cpu_infos[1].active_time) - last_active_cpu_time2;
	
	percent2 = (delta_cpu2/delta_system);
	if(percent2 < 0) percent2 = 0.00;
	if(percent2 > 1) percent2 = 1.00;
	last_active_cpu_time2 = (double)info.cpu_infos[1].active_time;
	last_system_time = (double)system_time();
}

void StatusWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case TURN_OFF_CPU_1:
		{
			if(_kget_cpu_state_(0) == 0)
			{
				CPU2->SetEnabled(true);
				_kset_cpu_state_(0,1);
			}
			else
			{
				CPU2->SetEnabled(false);
				_kset_cpu_state_(0,0);
				cpu1_usage->SetText("CPU 1: OFF");	
				cpu1_usage->Update(0);
			}
		}break;
		
		case TURN_OFF_CPU_2:
		{
			if(_kget_cpu_state_(1) == 0)
			{	
				CPU1->SetEnabled(true);
				_kset_cpu_state_(1,1);
			}
			else
			{
				CPU1->SetEnabled(false);
				_kset_cpu_state_(1,0);
				cpu2_usage->SetText("CPU 2: OFF");	
				cpu2_usage->Update(0);
			}
		}break;
		case MISZA_BUTTON_PRESSED:
		{
		   	BAlert* myabout = new BAlert("errormsg", "Short little poem\nReally beats the hell out of\nAn error message", "   I Love Poetry   ", NULL , NULL, B_WIDTH_FROM_WIDEST, B_WARNING_ALERT);
   	    	myabout->Go();
		
		}break;
		
		case STARTME:
		{		//get the ram values again as they have changed
				system_info info; 
				get_system_info(&info);
				max = (info.max_pages*B_PAGE_SIZE)/(1024*1024);
				used = (info.used_pages*B_PAGE_SIZE)/(1024*1024);
		
				UpdateCPUPercent();
			
				BString cpu1_label;
				BString cpu2_label;
				cpu1_label << "CPU 1: " << (float)percent*100 << "%";
				cpu2_label << "CPU 2: " << (float)percent2*100 << "%";
				//make the buttons update if cpu status changes outside app
				if(_kget_cpu_state_(0) == 0)
				{
					CPU1->SetValue(B_CONTROL_ON);
					CPU2->SetEnabled(false);
					if(cpu1_usage->CurrentValue() != 0)
					{	
					cpu1_usage->Reset();	
					cpu1_usage->SetText("CPU 1: OFF");
					}
					//cpu1_usage->Update(0);
				}
				else if(_kget_cpu_state_(0) == 1)
				{	
					if(percent > lastpercent)
					{
						cpu1_usage->Update((percent - lastpercent)*100);
					}
					else if(percent < lastpercent)
					{
						cpu1_usage->Update((-(lastpercent-percent))*100);				
					}
				
					cpu1_usage->SetText(cpu1_label.String());
					CPU1->SetValue(B_CONTROL_OFF);
					CPU2->SetEnabled(true);
				}
				if(_kget_cpu_state_(1) == 0)
				{	
					CPU2->SetValue(B_CONTROL_ON);
					CPU1->SetEnabled(false);
					//cpu2_usage->SetText("CPU 2: OFF");	
					if(cpu2_usage->CurrentValue() != 0.0)
					{
						cpu2_usage->Reset();
						cpu2_usage->SetText("CPU 2: OFF");
					}
				}
				else if(_kget_cpu_state_(1) == 1)
				{	
					if(percent2 > lastpercent2)
					{
						cpu2_usage->Update((percent2 - lastpercent2)*100);
					}
					else if(lastpercent2 > percent2)
					{
						cpu2_usage->Update((-(lastpercent2-percent2))*100);
					}
				
					cpu2_usage->SetText(cpu2_label.String());	
					CPU2->SetValue(B_CONTROL_OFF);
					CPU1->SetEnabled(true);
				}
				
				if(used > last_used)
				{	//if the used reading is > than last time
					//increment the status bar the amount of the difference
					ram_usage->Update(used - last_used);
					
					BString TRAILING;
					TRAILING << (int32)used << " / " << (int32)(max) << "MB"; 
					ram_usage->SetTrailingText(TRAILING.String());
					
				}
				else if(used < last_used)
				{//if the used reading is less than last time
				 //decrement the status bar, note: the minus sign in Update()
					ram_usage->Update(-(last_used - used));
					BString TRAILING;
					TRAILING << (int32)used << " / " << (int32)(max) << "MB"; 
					ram_usage->SetTrailingText(TRAILING.String());
				}
				last_used = used;//update the last ram state.
				lastpercent = percent;
				lastpercent2 = percent2;
		}break;
		
		default:
			BWindow::MessageReceived(msg);
	        break;
	}
}

bool StatusWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}
