#include <iostream>
#include <stdio.h>
#include <Application.h>  // Be's BApplication class, necessary for any GUI stuff
#include <Window.h>  // Be's BWindow class
#include <Rect.h>
#include <MenuItem.h>
#include <MenuField.h>
#include <TextControl.h>
#include <PopUpMenu.h>
#include <View.h>
#include <String.h>
#include <time.h>
#include <unistd.h>

const uint32 DATE_CHANGED = 'Dtch';
//custom BWindow subclass
class DateWindow : public BWindow
{
	public:
		DateWindow();
		virtual bool QuitRequested();
		virtual void MessageReceived(BMessage* msg);
	private:
		BView* parent;
		BPopUpMenu* Day;
		BPopUpMenu* Month;
		BPopUpMenu* Year;
		BTextControl* Date;
		
};
//function implementation of DateWindow() (contructor);
DateWindow :: DateWindow()
	: BWindow(BRect(50,50,300,250), "DateWindow", B_TITLED_WINDOW, 0)
{
	parent = new BView(Bounds(),"parent",B_FOLLOW_ALL,B_WILL_DRAW);
	AddChild(parent);
	
	parent->SetViewColor(51,102,152);
	Day = new BPopUpMenu("Day");
		for(int i=1;i<=31;i++)
		{
			BString label;
			if(i<10)
				label << "0" << int(i);
			else
				label << int(i);	
			Day->AddItem(new BMenuItem(label.String(),new BMessage(DATE_CHANGED)));
		}
			
	Month = new BPopUpMenu("Month");
		Month->AddItem(new BMenuItem("January",new BMessage(DATE_CHANGED)));
		Month->AddItem(new BMenuItem("February",new BMessage(DATE_CHANGED)));
		Month->AddItem(new BMenuItem("March",new BMessage(DATE_CHANGED)));
		Month->AddItem(new BMenuItem("April",new BMessage(DATE_CHANGED)));
		Month->AddItem(new BMenuItem("May",new BMessage(DATE_CHANGED)));
		Month->AddItem(new BMenuItem("June",new BMessage(DATE_CHANGED)));
		Month->AddItem(new BMenuItem("July",new BMessage(DATE_CHANGED)));
		Month->AddItem(new BMenuItem("August",new BMessage(DATE_CHANGED)));
		Month->AddItem(new BMenuItem("September",new BMessage(DATE_CHANGED)));
		Month->AddItem(new BMenuItem("October",new BMessage(DATE_CHANGED)));
		Month->AddItem(new BMenuItem("November",new BMessage(DATE_CHANGED)));
		Month->AddItem(new BMenuItem("December",new BMessage(DATE_CHANGED)));
	
	Year = new BPopUpMenu("Year");
		for(int i=2000;i<=2050;i++)
		{
			BString label;
				label << int(i);	
			Year->AddItem(new BMenuItem(label.String(),new BMessage(DATE_CHANGED)));
		}		
	//where we want the first item to be
	BRect items(10,10,100,30);
	//Add the menufields to the view
	parent->AddChild(new BMenuField(items,"_Day",NULL,Day));
	items.OffsetBy(0,30);
	parent->AddChild(new BMenuField(items,"_Month",NULL,Month));
	items.OffsetBy(0,30);
	parent->AddChild(new BMenuField(items,"_Year",NULL,Year));
	
	//Get the time stuff going on (crazy c time functions)
	time_t the_time;
	struct tm *tm_ptr;
	(void) time(&the_time);
	tm_ptr = localtime(&the_time);
	//Set the default date as today's
	Day->ItemAt((tm_ptr->tm_mday)-1)->SetMarked(true);
	Month->ItemAt(tm_ptr->tm_mon)->SetMarked(true);
	Year->ItemAt((tm_ptr->tm_year)-100)->SetMarked(true);
	
	Date = new BTextControl(BRect(10,120,210,140),"Date",NULL,NULL,NULL);
	parent->AddChild(Date);
	(Date->TextView())->MakeEditable(false);
	
	//Set the intial value in the box
	BString DATE;
	DATE << (Day->FindMarked())->Label() << " - " 
		 << (Month->FindMarked())->Label() << " - "
		 << (Year->FindMarked())->Label();
	Date->SetText(DATE.String());
}

void DateWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case DATE_CHANGED:
		{
			BString DATE;
			DATE << (Day->FindMarked())->Label() << " - " 
				 << (Month->FindMarked())->Label() << " - "
				 << (Year->FindMarked())->Label();
			Date->SetText(DATE.String());
		}break;
	}

}
// Called when the user clicks on the window's close box
bool DateWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}

int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.misza-datedropdown");//gotta have this
	//Create the window..
	BWindow* window = new DateWindow();
	window->Show();	//shows up the window
	app.Run();
	return 0;
}
