#include <iostream>
#include <stdio.h>
#include <Application.h>   // Be's BApplication class, necessary for any GUI stuff
#include <Window.h>  // Be's BWindow class
#include <Box.h>	   // Be's BBox class
#include <View.h>	   //Be's BView class
#include <string>
#include <Button.h>
#include <Roster.h>
#include <ColorControl.h>
#include <TextView.h>
#include <StringView.h>
#include <Alert.h>
#include "randgen.h"
#include <MessageRunner.h>
const uint32 BRENT_DO_THIS = 'DoIt';
const uint32 BRENT_DO_THIS3 = 'DoI2';
const uint32 BRENT_DO_THIS2 = 'DoI3';
class BrentWindow : public BWindow
{
	public:
		BrentWindow();
		virtual void MessageReceived(BMessage * msg);
		virtual bool QuitRequested();
		
	private:
	BBox* brents_bbox;
	BView* parent_view;
	RandGen rred,rblue,rgreen;
};
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,600,600), "Disco", B_TITLED_WINDOW,B_PULSE_NEEDED)
{
	SetPulseRate(200000);
	rgb_color bgcolor = ui_color(B_PANEL_BACKGROUND_COLOR);
	BRect b = Frame();
	b.OffsetTo(B_ORIGIN);
	parent_view = new BBox(b,"parent_view", B_FOLLOW_ALL, B_WILL_DRAW | B_FRAME_EVENTS | B_FULL_UPDATE_ON_RESIZE|B_PULSE_NEEDED, B_PLAIN_BORDER);
	parent_view->SetViewColor(bgcolor);
	AddChild(parent_view);
	
	BMessenger mymsnger(this);
	BMessage increment(BRENT_DO_THIS);

	BMessageRunner* berun = new BMessageRunner(mymsnger,&increment,500,-1);
}
void BrentWindow :: MessageReceived(BMessage* msg)
{
	static int numPresses=1;

	switch(msg->what)
	{
		case BRENT_DO_THIS:
		{
			
			int red = rred.RandInt(0,255);
			int blue = rblue.RandInt(0,255);
			int green = rgreen.RandInt(0,255);
			parent_view->SetViewColor(red,green,blue);
			parent_view->Invalidate();
		}
		break;
				
		default:
		BWindow :: MessageReceived(msg);// all other types go to the parent class's method.
		break;
	}
}
bool BrentWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}

int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.misza-clrflash");//gotta have this
	//Create the window..
	BWindow* window = new BrentWindow();
	
	window->Show();	//shows up the window
	
	app.Run();
	return 0;
}
