#include <iostream>
#include <stdio.h>
#include <Application.h>   // Be's BApplication class, necessary for any GUI stuff
#include <Window.h>  // Be's BWindow class
#include <Bitmap.h>
#include <View.h>
#include <Rect.h>
#include <Point.h>
#include <StorageKit.h>
#include <InterfaceKit.h>
#include <stdio.h>
#include <ColorControl.h>
#include <Point.h>
//some pretty functions for comparing rgb_colors (overloaded operators) stolen from be inc sample code ;)
static bool
CompareColors(const rgb_color a, const rgb_color b)
{
	return a.red == b.red
		&& a.green == b.green
		&& a.blue == b.blue
		&& a.alpha == b.alpha;
}

inline bool 
operator==(const rgb_color &a, const rgb_color &b)
{
	return CompareColors(a, b);
}

inline bool 
operator!=(const rgb_color &a, const rgb_color &b)
{
	return !CompareColors(a, b);
}

//a pretty silly attempt at having a dynamic BColorControl :P
class FastColor : public BColorControl
{
	public:
		FastColor(BPoint leftTop,color_control_layout matrix,float cellSide,
		const char* name,BMessage* message = NULL,bool bufferedDrawing = false);
		virtual void MouseUp(BPoint point);
		virtual void MouseDown(BPoint point);
	  	virtual void MouseMoved(BPoint point,uint32 transit,const BMessage* message);
	 private:
	 	BMessage* MISZA_MESSAGE;
	 	BPoint last_point;
	 	bool isOkToUpdate;
};
FastColor::FastColor(BPoint leftTop,color_control_layout matrix,float cellSide,const char* name,BMessage* message = NULL,bool bufferedDrawing = false)
 : BColorControl(leftTop,matrix,cellSide,name,message,bufferedDrawing)
{
	MISZA_MESSAGE = message;
	isOkToUpdate = false;
	
}
void FastColor::MouseDown(BPoint point)
{
	isOkToUpdate = true;
	
	BColorControl::MouseDown(point);
}
void FastColor::MouseUp(BPoint point)
{
	isOkToUpdate = false;
	BColorControl::MouseUp(point);
}
void FastColor::MouseMoved(BPoint point,uint32 transit,const BMessage* message)
{

	if (last_point != point && isOkToUpdate)
		Window()->PostMessage(MISZA_MESSAGE);
	
	BColorControl::MouseMoved(point,transit,message);
	last_point = point;
}
const uint32 TINT_CHANGED = 'TtCd';

//just a silly view to draw the bitmap
class PictureView : public BView
{
	public:
		PictureView(BBitmap* bitmap, BRect r);
		virtual void Draw(BRect drawRect);
		void SetBitmap(BBitmap* bitmap) { drawme = bitmap; Invalidate();}
	private:
		BBitmap* drawme;
};

PictureView::PictureView(BBitmap* bitmap, BRect r) : BView(r,"pictureview",B_FOLLOW_NONE,B_WILL_DRAW)
{
	drawme = bitmap;
}

void PictureView::Draw(BRect drawRect)
{
	SetDrawingMode(B_OP_ALPHA);
	DrawBitmap(drawme,BPoint(0,0));
}
//the main window
//custom BWindow subclass
class PictureWindow : public BWindow
{
	public:
		PictureWindow();
		void TintBitmap(rgb_color tint);
		virtual void MessageReceived(BMessage* msg);
		virtual bool QuitRequested();
	private:
		BBitmap* source;
		BBitmap* modded;
		BView* clrbox;
		PictureView* PVsource;
		PictureView* PVmodded;
		FastColor* Tinter;
};
//function implementation of BrentWindow() (contructor);
PictureWindow :: PictureWindow()
	: BWindow(BRect(50,50,350,250), "Icon Tinter! :-)", B_TITLED_WINDOW, B_NOT_ZOOMABLE|B_NOT_RESIZABLE|B_ASYNCHRONOUS_CONTROLS)
{
	BView* parent = new BView(Bounds(),"parent",B_FOLLOW_ALL,B_WILL_DRAW);
	AddChild(parent);
	parent->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));


	BFile file("/boot/beos/apps/NetPositive",B_READ_ONLY);
	BAppFileInfo net_p_app_info(&file);
	
	BBitmap* bitmap = new BBitmap(BRect(0,0,31,31),B_CMAP8);
	net_p_app_info.GetIcon(bitmap,B_LARGE_ICON);
	
	BFile file2("/boot/beos/apps/NetPositive",B_READ_ONLY);
	BAppFileInfo app_info(&file2);
	
	BBitmap* bitmap2 = new BBitmap(BRect(0,0,31,31),B_CMAP8);
	app_info.GetIcon(bitmap2,B_LARGE_ICON);
	
	source = bitmap2;
	rgb_color tint = {255,255,255};
	
	TintBitmap(tint);
	
	clrbox = new BView(BRect(10,150,30,170),"clrbox",B_FOLLOW_NONE,B_WILL_DRAW);
	parent->AddChild(clrbox);
	
	clrbox->SetViewColor(tint);
	PVsource = new PictureView(bitmap,BRect(10,10,41,41));
	PVsource->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	parent->AddChild(PVsource);
	
	PVmodded = new PictureView(modded,BRect(45,10,77,41));
	PVmodded->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	parent->AddChild(PVmodded);
	
	Tinter = new FastColor(BPoint(10,80),B_CELLS_32x8,4.0,"ctrlbox",new BMessage(TINT_CHANGED),true);
	parent->AddChild(Tinter);
	Tinter->SetValue(tint);
}
// Called when the user clicks on the window's close box
bool PictureWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}

void PictureWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
	case TINT_CHANGED:
	{
		rgb_color updated_colour = Tinter->ValueAsColor();
		clrbox->SetViewColor(updated_colour);
		clrbox->Invalidate();
		TintBitmap(updated_colour);
		PVmodded->SetBitmap(modded);
	}break;
	
	default:
		BWindow::MessageReceived(msg);
	break;
	}
}
void PictureWindow::TintBitmap(rgb_color tint)
{
	modded = new BBitmap(BRect(0,0,31,31),B_RGB32);
	modded->SetBits(source->Bits(),source->BitsLength(),0,B_CMAP8);
	
	unsigned char* _p = (unsigned char*)(source->Bits());
	bool A[1024];
	
	for(int i=0;i<1024;i++)
	{
		if(_p[i] == B_TRANSPARENT_MAGIC_CMAP8)
			A[i] = true;
		else
			A[i] = false;
	}
	unsigned char* p = (unsigned char*)(modded->Bits());
	
	int temp_count=0;
	for(int i=0;i<=4096;i++)
	{
		if(temp_count != 3)
		{
			if(temp_count == 2)//red
			{	
				if(tint.red - (255 - (int)p[i]) <=0)
					p[i] = (unsigned char)0;
				else
				p[i] = (unsigned char) (tint.red - (255 - (int)p[i]));
			}
			
			else if(temp_count == 1)//green
			{	
				if(tint.green - (255 - (int)p[i]) <=0)
					p[i] = (unsigned char)0;
				else
				p[i] = (unsigned char) (tint.green - (255 - (int)p[i]));
			}	
			else if(temp_count == 0)//blue
			{	
				if(tint.blue - (255 - (int)p[i]) <=0)
					p[i] = (unsigned char)0;
				else
				p[i] = (unsigned char) (tint.blue - (255 - (int)p[i]));
			}
			temp_count++;
		}
		else
		{
			if(A[i/4] == true)
				p[i] = (unsigned char)0;
			temp_count = 0;
		}
	}
}
int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.misza-picturewindow");//gotta have this
	//Create the window..
	BWindow* window = new PictureWindow();
	window->Show();	//shows up the window
	app.Run();
	return 0;
}
