#include <iostream>
#include <stdio.h>
#include <Application.h>   // Be's BApplication class, necessary for any GUI stuff
#include <Window.h>  // Be's BWindow class
#include <Box.h>	   // Be's BBox class
#include <View.h>	   //Be's BView class
#include <string>
#include <Button.h>
#include <Roster.h>
#include <InterfaceKit.h>
#include <OS.h>
#include <String.h>
#include <MessageRunner.h>
#include "randgen.h"
const uint32 INITIATE_COUNTDOWN = 'Init';
const uint32 INCREMENT_STATUS_BAR = 'Icr';
bool check_ = true;
rgb_color bgcolor = ui_color(B_PANEL_BACKGROUND_COLOR);

class MeltDownWindow : public BWindow
{
	public:
		MeltDownWindow();
		virtual void MessageReceived(BMessage * msg);
		virtual bool QuitRequested();
		virtual void FrameResized(float width, float height);
	private:
		//static status_t threadFunc(some_data* data);
		BStatusBar* BeStatus;
		BStatusBar* WinStatus;
		BString percent;
		BButton* button;
		BAlert* bewarning;
		BAlert* winwarning;
		BView* parent_view;
		BMessageRunner* berun;
		BMessageRunner* winrun;
		RandGen rred,rblue,rgreen;
		BView* some_block;
};



MeltDownWindow::MeltDownWindow() : BWindow(BRect(50,50,250,250),
"MeltDown", B_TITLED_WINDOW,B_NOT_RESIZABLE| B_NOT_ZOOMABLE)//

{
	
	parent_view = new BBox(Bounds(),"parent_view", B_FOLLOW_ALL, B_WILL_DRAW | B_FRAME_EVENTS, B_PLAIN_BORDER);
	
	
	parent_view->SetLowColor(bgcolor);
	parent_view->SetViewColor(bgcolor);
	AddChild(parent_view);
	
	/*------NEXT VIEW-----*/
	BRect r = parent_view->Bounds();
	r.InsetBy(10,10);
	BBox* meltdownbox = new BBox(r,"CPU Intensive OS Test", B_FOLLOW_ALL);
	//Set the color and Label of the BBox/view
	meltdownbox->SetLowColor(bgcolor);
	meltdownbox->SetViewColor(bgcolor);
	//Set the label
	meltdownbox->SetLabel("CPU Intensive OS Test");
	//add it to hierarchy
	parent_view->AddChild(meltdownbox);
	/*----SOME BUTTONS----*/
	BRect buttonski = parent_view->Bounds();
	buttonski.bottom -= 30;
	buttonski.right -= 30;
	buttonski.left += 10;
	buttonski.top = 130;
	button = new BButton(buttonski,"button","Begin Test", new BMessage(INITIATE_COUNTDOWN),B_NOT_RESIZABLE,B_WILL_DRAW|B_NAVIGABLE);
	button->SetTarget(this);
	button->MakeDefault(true);
	meltdownbox->AddChild(button);
	
	BRect statbarrect = parent_view->Bounds();
	
	statbarrect.top += 30;
	statbarrect.left += 20;
	statbarrect.right -=40;
	statbarrect.bottom -= 50;

	BeStatus = new BStatusBar(statbarrect,"BeStatus");
	rgb_color beblue = {50,150,255};
	BeStatus->SetBarColor(beblue);
	BeStatus->SetText("BeOS!");
	meltdownbox->AddChild(BeStatus);
	
	statbarrect.OffsetBy(0,40);
	WinStatus = new BStatusBar(statbarrect,"WinStatus");
	rgb_color winblue = {51,61,106};
	WinStatus->SetBarColor(winblue);
	WinStatus->SetText("Windows");
	meltdownbox->AddChild(WinStatus);
}

void MeltDownWindow :: MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case INITIATE_COUNTDOWN:
		{
		
		/* DO SOMETHING */
		
		if(BeStatus->CurrentValue() == 100.00 && WinStatus->CurrentValue() == 100.00)
		{	
		BeStatus->Reset("BeOS!");
		WinStatus->Reset("Windows");
		button->SetLabel("Begin Test");
  		
			break;
		}
		else{
		BMessenger mymsnger(this);
		BMessage increment(INCREMENT_STATUS_BAR);

		berun = new BMessageRunner(mymsnger,&increment,
		5000,-1);
		}

		}break;
	
		case INCREMENT_STATUS_BAR:
		{
		//cout << "calld" << endl;
		if(BeStatus->CurrentValue() == 100.00 && WinStatus->CurrentValue() == 100.00)
		{
			BeStatus->Invalidate();
			WinStatus->Invalidate();
			bewarning= new BAlert("warning",//Windows Crashed @ 75%! 
			"BeOS Wins! Everytime.....","Woohoo!",NULL,NULL,
			B_WIDTH_AS_USUAL,B_STOP_ALERT);
			bewarning->Go(NULL);
			delete berun;
			button->SetEnabled(true);
			button->SetLabel("Clear");

			break;
		}
		int red = rred.RandInt(0,255);
		int blue = rblue.RandInt(0,255);
		int green = rgreen.RandInt(0,255);
	
		int red2 = rred.RandInt(0,255);
		int blue2 = rblue.RandInt(0,255);
		int green2 = rgreen.RandInt(0,255);
		
		rgb_color c1 = {red,green,blue};
		rgb_color c2 = {red2,green2,blue2};
		
		button->SetEnabled(false);
		WinStatus->Update(0.25);
		WinStatus->SetBarColor(c2);
		if(BeStatus->CurrentValue() < 100.00)
		{BeStatus->Update(1);
		
		BeStatus->SetBarColor(c1);
		}
		else if(check_){
		BeStatus->Invalidate();
		check_ = false;}

		}break;
		
		default:
			BWindow::MessageReceived(msg);
			break;
	}
}
void MeltDownWindow :: FrameResized(float width, float height)
{
}
// Called when the user clicks on the window's close box
bool MeltDownWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}

int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.misza-meltdown");//gotta have this
	//Create the window..
	BWindow* window = new MeltDownWindow();
	window->Show();	//shows up the window
	app.Run();
	return 0;
}