#include <iostream>
#include <stdio.h>
#include <Application.h>   // Be's BApplication class, necessary for any GUI stuff
#include <Window.h>  // Be's BWindow class
#include <Box.h>	   // Be's BBox class
#include <View.h>	   //Be's BView class
#include <string>
#include <Button.h>
#include <Roster.h>
#include <ColorControl.h>
#include <TextView.h>
#include <StringView.h>
#include <Alert.h>
#include <CheckBox.h>
#include <MenuBar.h>
#include <MenuItem.h>
#include <InterfaceKit.h>
const uint32 BRENT_DO_THIS = 'DoIt';
const uint32 BRENT_ABOUT = 'Abt';

class BrentWindow : public BWindow
{
	public:
		BrentWindow();
		virtual void MessageReceived(BMessage * msg);
		virtual bool QuitRequested();
	private:
		BBox* brents_bbox;
		BView* parent_view;
		BCheckBox* mycheckbox;
		BMenuBar* mymenubar;
};
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,300,300), "Light Switch", B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{

	
	rgb_color bgcolor = ui_color(B_PANEL_BACKGROUND_COLOR);
	BRect b = Frame();
	b.OffsetTo(B_ORIGIN);
	parent_view = new BBox(b,"parent_view", B_FOLLOW_ALL, B_WILL_DRAW | B_FRAME_EVENTS | B_FULL_UPDATE_ON_RESIZE, B_PLAIN_BORDER);
	parent_view->SetViewColor(bgcolor);
	AddChild(parent_view);
	
	mymenubar = new BMenuBar(b,"mymenubar",B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP,B_ITEMS_IN_ROW,true);
	parent_view->AddChild(mymenubar);
	mymenubar->SetViewColor(0,0,255);
	BMenu* myfile = new BMenu("File",B_ITEMS_IN_COLUMN);
	mymenubar->AddItem(myfile);
	
	BMenuItem* myaboutitem = new BMenuItem("About...",new BMessage(BRENT_ABOUT),'A',0);
	myfile->AddItem(myaboutitem);
	
	
	
	
	b.InsetBy(20,20);//BRect(10,10,135,115)
	brents_bbox = new BBox(b,"Brent's BBox", B_FOLLOW_ALL);
	brents_bbox->SetViewColor(bgcolor);//bgcolor
	brents_bbox->SetLabel("This Shows The Light Status");
	parent_view->AddChild(brents_bbox);
	
	
	mycheckbox = new BCheckBox(BRect(20,30,200,40),"mycheckbox","LightSwitch", new BMessage(BRENT_DO_THIS),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	mycheckbox->SetLabel("Light Switch");
	brents_bbox->AddChild(mycheckbox);	
	
	
	//BStringView* mystringview = new BStringView(BRect(20,50,200,150),"name","SOME TEXT");
	//brents_bbox->AddChild(mystringview);
	brents_bbox->MovePenTo(30.0,30.0);
	brents_bbox->DrawString("cool");

}
void BrentWindow :: MessageReceived(BMessage* msg)
{
	//static int numPresses=1;

	switch(msg->what)
	{
	
		case BRENT_ABOUT:
		{
		BAlert* myaboutbox = new BAlert("about", "LightSwitch 1.0\nBy Brent Miszalski","Awesome!",NULL,NULL,B_WIDTH_FROM_LABEL,B_EVEN_SPACING,B_IDEA_ALERT);
		myaboutbox->Go();
		
		} 
		break;
		case BRENT_DO_THIS:
		{
			if(mycheckbox->Value() == B_CONTROL_OFF){
			
			parent_view->SetLowColor(0,0,0);
			parent_view->SetViewColor(0,0,0);
			parent_view->SetHighColor(255,255,0);
			
			brents_bbox->SetLowColor(0,0,0);
			brents_bbox->SetViewColor(0,0,0);
			brents_bbox->SetHighColor(255,255,0);
			
			mycheckbox->SetLowColor(0,0,0);
			mycheckbox->SetViewColor(0,0,0);
			mycheckbox->SetHighColor(255,255,0);
			
			
			brents_bbox->SetLabel("Off");
			mycheckbox->SetLabel("Click to turn on the Light");
			brents_bbox->Invalidate();
			parent_view->Invalidate();
			mycheckbox->Invalidate();
			
			}
			else{
			parent_view->SetLowColor(255,255,0);
			parent_view->SetViewColor(255,255,0);
			parent_view->SetHighColor(0,0,0);
			
			brents_bbox->SetLowColor(255,255,0);
			brents_bbox->SetViewColor(255,255,0);
			brents_bbox->SetHighColor(0,0,0);
			
			mycheckbox->SetLowColor(255,255,0);
			mycheckbox->SetViewColor(255,255,0);
			mycheckbox->SetHighColor(0,0,0);
			
			
			brents_bbox->SetLabel("On");
			mycheckbox->SetLabel("Click to turn off the Light");
			brents_bbox->Invalidate();
			parent_view->Invalidate();
			mycheckbox->Invalidate();
			}
		}
		break;
				
		default:
		BWindow :: MessageReceived(msg);// all other types go to the parent class's method.
		break;
	}
}
// Called when the user clicks on the window's close box
bool BrentWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}

int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.Brent-bbox");//gotta have this
	//Create the window..
	BWindow* window = new BrentWindow();
	window->Show();	//shows up the window
	app.Run();
	return 0;
}
