#include <iostream>
#include <stdio.h>
#include <Application.h>   // Be's BApplication class, necessary for any GUI stuff
#include <Window.h>  // Be's BWindow class
#include <Box.h>	   // Be's BBox class
#include <View.h>	   //Be's BView class
#include <string>
#include <Button.h>
#include <Roster.h>
#include <ColorControl.h>
#include <TextView.h>
#include <StringView.h>
#include <Alert.h>
#include <InterfaceKit.h>
#include <MessageRunner.h>
const uint32 WINDOW_SLIDE = 'Sld';
const uint32 INIT_WINDOW_SLIDE = 'Isld';
class BrentWindow : public BWindow
{
	public:
		BrentWindow();
		virtual void MessageReceived(BMessage * msg);
		virtual bool QuitRequested();
		
	private:
	BButton* expander;
	BButton* secret;
	BView* parent_view;
	int32 expand_status;
	int32 window_status;
	BMessageRunner* window_slide;
	float slide_amount;
	BBox* mybox;
};
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,250,250), "Slidy Window Demo", B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE|B_PULSE_NEEDED)
{
	
	slide_amount = 0;
		expand_status = -1;
		
	rgb_color bgcolor = ui_color(B_PANEL_BACKGROUND_COLOR);
	BRect b = Frame();
	b.OffsetTo(B_ORIGIN);
	parent_view = new BBox(b,"parent_view", B_FOLLOW_ALL, B_WILL_DRAW | B_FRAME_EVENTS | B_FULL_UPDATE_ON_RESIZE|B_PULSE_NEEDED, B_PLAIN_BORDER);
	parent_view->SetViewColor(bgcolor);
	AddChild(parent_view);
	BRect r = Bounds();
	r.InsetBy(10,10);
	BBox* mybox = new BBox(r,"BBox", B_FOLLOW_ALL);
	//Set the color and Label of the BBox/view
	mybox->SetLabel("BBox");
	parent_view->AddChild(mybox);
	
	
	r.InsetBy(30,30);
	r.bottom-=90;
	r.right-=30;
	expander = new BButton(r,"expander",
	"Expand Window",new BMessage(INIT_WINDOW_SLIDE));
	expander->MakeDefault(true);
	mybox->AddChild(expander);
	
	secret = new BButton(BRect(230,40,320,60),"secret",
	"Secret Button!",new BMessage(INIT_WINDOW_SLIDE));
	mybox->AddChild(secret);

}
void BrentWindow :: MessageReceived(BMessage* msg)
{
	static int numPresses=1;

	switch(msg->what)
	{
		case INIT_WINDOW_SLIDE:
		{
		BMessenger mymsnger(this);
		BMessage postmeplease(WINDOW_SLIDE);
		
		expander->SetEnabled(false);
		expander->SetLabel("Zoom Zoom");
		secret->SetEnabled(false);
		//window_status = 0;
		window_slide = new BMessageRunner(mymsnger,&postmeplease,
		5000,-1);
		
		
		}
		
		case WINDOW_SLIDE:
		{

			if(expand_status == 1)
			{// no where to go except contract
			// set status to -1,if lim reached, del window_slide
			//exit
		
			
			ResizeBy(-20,0);
			slide_amount -= 20;
			if(slide_amount == -200)
			{	//if lim is reached, del msnger and exit?
			
			
			expand_status = -1;
			slide_amount = 0;
			delete window_slide;
			expander->SetLabel("Expand Window");
			expander->SetEnabled(true);
			
			return;
			}
			
			}

			if(expand_status == -1)
			{// nowhere to go except expand
			//set status to 1, if lim reached, del window_slide
			//exit
			
			
			ResizeBy(20,0);
			slide_amount += 20;
			if(slide_amount == 200)
			{	//if lim is reached, del msnger and exit?
			
			
			expand_status = 1;
			slide_amount = 0;
			delete window_slide;
			expander->SetLabel("Collapse Window");
			expander->SetEnabled(true);
			secret->SetEnabled(true);
			return;
			}
		}
		}
		break;
				
		default:
		BWindow :: MessageReceived(msg);// all other types go to the parent class's method.
		break;
	}
}


// Called when the user clicks on the window's close box
bool BrentWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}

int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.misza-boutlinelistviewdemo");//gotta have this
	//Create the window..
	BWindow* window = new BrentWindow();
	
	window->Show();	//shows up the window
	
	app.Run();
	return 0;
}
